---
.title = "CV",
.author = "Martin Ashby",
.date = @date("2024-04-19T20:38:00Z"),
.layout = "single.html",
---

# Martin Ashby - Software Engineer

I solve problems in software. My two strongest skills are technical design & architecture, and debugging.

## Education / Employment History

- 2018 - Present    Patients Know Best, Software engineer
- 2010 - 2018       The Phoenix Partnership, Software Engineer
- 2007 - 2010       University of Warwick, Physics BSc (1st class)

## Projects

In 2023/2024 I am transitioning PKBs primary web application from WildFly to Spring Boot. This is an important step for improving our security, and for reducing onboarding effort both for new developers and mental overhead for the existing development team. This requires deep knowledge of all the libraries and technologies used in the existing application and their analogs in Spring Boot. It also requires a lot of debugging!

In 2022/2023 I helped to define a new software architecture for PKB. The new architecture had to overcome several pain points of the existing system, and also enable new possibilities. I designed this system in conjunction with the CTO, product management team, and my peers. The new architecture better allowed PKB to focus on their core competencies while outsourcing essential but non-core items such as authentication, audit and orchestration to managed or self-hosted third party software. This required collaboration with many groups including co-developers, product management teams, and third parties.

From 2021 I have led the 'application & infrastructure engineering' team at PKB. Our team is responsible for implementing cross-cutting system changes to improve the security and scalability of PKB. This requires good domain knowledge and situational awareness in order to choose the right projects to ensure PKB's future operational needs are met. It also requires the soft skills necessary to take care of a small team (2-4 engineers, senior and junior)

From 2021 I have been chair of PKB's 'architecture clinic', a weekly forum for discussing PKB architecture and design. This requires both the technical chops to understand the problems that the engineering team face, as well as the soft skills to ensure that decisions are made and that engineers are on-board with them.

In 2020 I moved PKB from running on co-located hosting using docker-swarm at a small provider, to Google Cloud Platform using kubernetes. This allowed PKB to significantly improve their operational security, as well as enabled accelerated development by using google managed services.  This required learning about kubernetes, google cloud platform, networking in a cloud environment, and a host of other technical details. This also required planning and managing the final switchover in conjunction with my co-developers and our support team.

In 2016-2017 I worked on TPP's mobile applications and their backend; expanding their existing backend to support new patient-facing mobile applications. I also worked on the client side of the initial version of TPP's [Airmid UK](https://play.google.com/store/apps/details?id=px.mw.android.aihealth.patient.live.production&pcampaignid=web_share) app. 

I am comfortable using a variety of programming languages, and I have used a variety of frameworks. My current work uses Java and Spring. I'm very open to learning new technology as it becomes necessary or interesting. My current favourite language is Zig. Ask me why!

## Links

- [Blog](https://mfashby.net)
- [GitHub](https://github.com/MFAshby)
- [Code](https://code.mfashby.net/)

## Contact

[martin@mfashby.net](mailto:martin@mfashby.net)