---
.title = "Manjaro",
.author = "Martin Ashby",
.date = @date("2021-09-21T20:03:48+01:00"),
.layout = "single.html",
.custom = {"comments": true},
---

I've used [Ubuntu](https://ubuntu.com/) linux for many years, but just recently it's started to become a bit more difficult due to proliferation of package managers. With the introduction of snap, flatpak, I'm never quite sure where I should be getting my software from.

I've occasionally experimented with other distributions, but usually found them disadvantageous in some ways. For example, debian is quite stable, but doesn't usually ship the latest and greatest upstream software.

I began to use [Manjaro](https://manjaro.org/) linux as it was the default operating system shipped on my [Pinebook Pro](https://www.pine64.org/pinebook-pro/), and I found the experience pretty refreshing. It's based on [Arch](https://archlinux.org/) linux but ships with a bit more pre-installed stuff. It also has great support for ARM based hardware. The Arch wiki and Arch User Repository are really great in my opinion, and with tools like `pamac` I can install a huge variety of stuff just with a few commands, even including building some software from source where there's no binary distribution.

I'm probably going to experiment with [NixOS](https://nixos.org/) next, as I like the idea of reproducible installations. I'll likely try it on my Raspberry PI home server first. For bonus points, I'll also try a [ZFS](https://en.wikipedia.org/wiki/ZFS) based installation which should hopefully make backups a breeze.

